---
title: CanvasRenderingContext2D.createPattern()
slug: Web/API/CanvasRenderingContext2D/createPattern
tags:
  - API
  - Canvas
  - CanvasRenderingContext2D
  - Method
  - Reference
---
<div>{{APIRef}}</div>

<p>The <code><strong>CanvasRenderingContext2D</strong></code><strong><code>.createPattern()</code></strong> method of the Canvas 2D API creates a pattern using the specified image and repetition. This method returns a {{domxref("CanvasPattern")}}.</p>

<p>This method doesn't draw anything to the canvas directly. The pattern it creates must be assigned to the {{domxref("CanvasRenderingContext2D.fillStyle")}} or {{domxref("CanvasRenderingContext2D.strokeStyle")}} properties, after which it is applied to any subsequent drawing.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">CanvasPattern <var>ctx</var>.createPattern(<var>image</var>, <var>repetition</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>image</code></dt>
 <dd>A {{domxref("CanvasImageSource")}} to be used as the pattern's image. It can be any of the following:
 <ul>
  <li>{{domxref("HTMLImageElement")}} ({{HTMLElement("img")}})</li>
  <li>{{domxref("SVGImageElement")}} ({{HTMLElement("image")}})</li>
  <li>{{domxref("HTMLVideoElement")}} ({{HTMLElement("video")}}, by using the capture of the video)</li>
  <li>{{domxref("HTMLCanvasElement")}} ({{HTMLElement("canvas")}})</li>
  <li>{{domxref("ImageBitmap")}}</li>
  <li>{{domxref("OffscreenCanvas")}}</li>
 </ul>
 </dd>
 <dt><code>repetition</code></dt>
 <dd>A {{domxref("DOMString")}} indicating how to repeat the pattern's image. Possible values are:
 <ul>
  <li><code>"repeat"</code> (both directions)</li>
  <li><code>"repeat-x"</code> (horizontal only)</li>
  <li><code>"repeat-y"</code> (vertical only)</li>
  <li><code>"no-repeat"</code> (neither direction)</li>
 </ul>
 If <code>repetition</code> is specified as an empty string (<code>""</code>) or {{jsxref("null")}} (but not {{jsxref("undefined")}}), a value of <code>"repeat"</code> will be used.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<dl>
 <dt>{{domxref("CanvasPattern")}}</dt>
 <dd>An opaque object describing a pattern.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Creating_a_pattern_from_an_image">Creating a pattern from an image</h3>

<p>This example uses the <code>createPattern()</code> method to create a {{domxref("CanvasPattern")}} with a repeating source image. Once created, the pattern is assigned to the canvas context's fill style and applied to a rectangle.</p>

<p>The original image looks like this:</p>

<p><img alt="A flowery pattern" src="https://mdn.mozillademos.org/files/222/Canvas_createpattern.png" style="height: 117px; width: 86px;"></p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html">&lt;canvas id="canvas" width="300" height="300"&gt;&lt;/canvas&gt;
</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js; highlight:[7]">var canvas = document.getElementById('canvas');
var ctx = canvas.getContext('2d');

var img = new Image();
img.src = 'https://mdn.mozillademos.org/files/222/Canvas_createpattern.png';
img.onload = function() {
  var pattern = ctx.createPattern(img, 'repeat');
  ctx.fillStyle = pattern;
  ctx.fillRect(0, 0, 300, 300);
};
</pre>

<p>{{ EmbedLiveSample('Creating_a_pattern_from_an_image', 700, 310) }}</p>

<h3 id="Creating_a_pattern_from_a_canvas">Creating a pattern from a canvas</h3>

<p>In this example we create a pattern from the contents of an offscreen canvas. We then apply it to the fill style of our primary canvas, and fill that canvas with the pattern.</p>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js">// Create a pattern, offscreen
const patternCanvas = document.createElement('canvas');
const patternContext = patternCanvas.getContext('2d');

// Give the pattern a width and height of 50
patternCanvas.width = 50;
patternCanvas.height = 50;

// Give the pattern a background color and draw an arc
patternContext.fillStyle = '#fec';
patternContext.fillRect(0, 0, patternCanvas.width, patternCanvas.height);
patternContext.arc(0, 0, 50, 0, .5 * Math.PI);
patternContext.stroke();

// Create our primary canvas and fill it with the pattern
const canvas = document.createElement('canvas');
const ctx = canvas.getContext('2d');
const pattern = ctx.createPattern(patternCanvas, 'repeat');
ctx.fillStyle = pattern;
ctx.fillRect(0, 0, canvas.width, canvas.height);

// Add our primary canvas to the webpage
document.body.appendChild(canvas);</pre>

<h4 id="Result">Result</h4>

<p>{{ EmbedLiveSample('Creating_a_pattern_from_a_canvas', 700, 160) }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "scripting.html#dom-context-2d-createpattern", "CanvasRenderingContext2D.createPattern")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CanvasRenderingContext2D.createPattern")}}</p>

<h3 id="Gecko-specific_notes">Gecko-specific notes</h3>

<ul>
 <li>Starting with Gecko 5.0 {{geckoRelease("5.0")}}, specifying a <code>null</code> or <code>undefined</code> image correctly throws a <code>TYPE_MISMATCH_ERR</code> exception.</li>
 <li>Starting with Gecko 16.0 {{geckoRelease("16.0")}}, specifying <code>null</code> for the <code>repetition</code> parameter is now allowed and results in the repetition being set to <code>"repeat"</code> ({{bug(762657)}}).</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>The interface defining this method: {{domxref("CanvasRenderingContext2D")}}</li>
 <li>{{domxref("CanvasPattern")}}</li>
</ul>
